'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.goalMiddleware = undefined;

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

exports.getVariant = getVariant;
exports.activate = activate;

var _reduxReporter = require('redux-reporter');

var _reduxReporter2 = _interopRequireDefault(_reduxReporter);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getActiveExperiments() {
    return window['optimizely'] && window['optimizely'].activeExperiments ? window['optimizely'].activeExperiments : []; // eslint-disable-line
}

function getVariationMap() {
    return window['optimizely'].variationMap || {}; // eslint-disable-line
}

function isEnabled(EXPERIMENT_ID) {
    return true; // todo, actually check, although this is an extraneious check
}

function getExperimentId(EXPERIMENT_NAME) {
    // todo
}

function isActive(EXPERIMENT_ID) {
    var activeExperiments = getActiveExperiments();
    var found = activeExperiments.filter(function (activeExperimentId) {
        return activeExperimentId === EXPERIMENT_ID;
    });
    return !!found.length;
}

function getVariant(EXPERIMENT_ID) {
    var variationMap = getVariationMap();
    if (isEnabled(EXPERIMENT_ID) && isActive(EXPERIMENT_ID)) {
        return variationMap[EXPERIMENT_ID];
    }
    return null;
}

function activate(EXPERIMENT_ID) {

    if (!isEnabled(EXPERIMENT_ID)) {
        return false;
    }

    if (!isActive(EXPERIMENT_ID)) {
        // only activate, enabled experiment
        window['optimizely'] = window['optimizely'] || []; // eslint-disable-line
        window['optimizely'].push(["activate", EXPERIMENT_ID]); // eslint-disable-line
    }

    return isActive(EXPERIMENT_ID);
}

exports.default = function (experimentId) {
    var suppressActivateOnRender = arguments.length <= 1 || arguments[1] === undefined ? false : arguments[1];
    return function (Wrapped) {
        var Wrapper = function (_Component) {
            (0, _inherits3.default)(Wrapper, _Component);

            function Wrapper() {
                (0, _classCallCheck3.default)(this, Wrapper);
                return (0, _possibleConstructorReturn3.default)(this, (0, _getPrototypeOf2.default)(Wrapper).apply(this, arguments));
            }

            (0, _createClass3.default)(Wrapper, [{
                key: 'render',
                value: function render() {
                    var isActive = false;
                    if (!suppressActivateOnRender) {
                        isActive = activate(experimentId);
                    }

                    var variant = getVariant(experimentId);

                    return _react2.default.createElement(Wrapped, (0, _extends3.default)({ isActive: isActive,
                        variant: variant }, this.props));
                }
            }]);
            return Wrapper;
        }(_react.Component);

        Wrapper.propTypes = {
            experimentId: _react.PropTypes.string,
            suppressActivateOnRender: _react.PropTypes.bool
        };

        return Wrapper;
    };
};

var goalMiddleware = (0, _reduxReporter2.default)(function (_ref) {
    var type = _ref.type;
    var payload = _ref.payload;


    window.optimizely = window.optimizely || [];
    window.optimizely.push(['trackEvent', type, payload]);
}, function (_ref2) {
    var _ref2$meta = _ref2.meta;
    var meta = _ref2$meta === undefined ? {} : _ref2$meta;
    return meta.experiments;
});

exports.goalMiddleware = goalMiddleware;